OnixBrick = class("OnixBrick", Brick)

function OnixBrick:initialize(x, y, mode)
	Brick.initialize(self, x, y)
	self.onixMode = mode
	local points
	local i, j
	if mode == "TopLeft" then
		points = {0,0,  32,0,  0,16}
		i, j = 9, 21
	elseif mode == "TopRight" then
		points = {0,0,  32,0,  32,16}
		i, j = 9, 20
	elseif mode == "BottomLeft" then
		points = {0,0,  32,16,  0,16}
		i, j = 8, 21
	elseif mode == "BottomRight" then
		points = {32,0,  32,16,  0,16}
		i, j = 8, 20
	else --mode == "Full"
		points = {0,0,  32,0,  32,16,  0,16}
		i, j = 8, 19
	end
	self:setShape(shapes.newPolygonShape(unpack(points)))
	self.rect = rects.brick[i][j]
	self.hitAni = mode.."OnixShine"
	self.health = 100
	self.armor = 2
	self.points = 500
	self.brickType = "OnixBrick"
	self.essential = false
end

function OnixBrick:takeDamage(dmg, str)
	Brick.takeDamage(self, dmg, str)
	self:playAnimation(self.hitAni)
end