MainMenuState = class("MainMenuState")

function MainMenuState:initialize()
	local dim = {}
	local width = 250
	local height = 40
	local yoffset = 30
	local padding = 5

	local dim = {}
	for i = 1, 5 do
		dim[i] = {window.w/2 - width/2, window.h/2 + yoffset + (height + padding) * (i-1), width, height}
	end
	self.buttons = {}
	self.buttons[1] = Button:new(dim[1], {text = "Play", font = font["Arcade30"]}, function()
		game:push(LevelSelectState:new())
	end)
	self.buttons[2] = Button:new(dim[2], {text = "Playlist", font = font["Arcade30"]}, function()
		game:push(LevelSelectState:new("playlist"))
	end)
	self.buttons[3] = Button:new(dim[3], {text = "Editor", font = font["Arcade30"]}, function()
		game:push(EditorState:new())
	end)
	self.buttons[4] = Button:new(dim[4], {text = "Options", font = font["Arcade30"]}, function()
		game:push(OptionState:new())
	end)
	self.buttons[5] = Button:new(dim[5], {text = "Credits", font = font["Arcade30"]}, function()
		print("Game made by:")
		print("\tSuperjustinbros - Director, Designer, and Artist")
		print("\tMr.Block - Programmer")
	end)
end

function MainMenuState:update(dt)
	for _, button in pairs(self.buttons) do
		button:update(dt)
	end
end

function MainMenuState:draw()
	love.graphics.setColor(100, 100, 100)
	love.graphics.rectangle("fill", 0, 0, window.w, window.h)

	love.graphics.setColor(255, 255, 255)
	love.graphics.setFont(font["Arcade100"])
	love.graphics.printf("Otaku-Ball", 0, window.h/2 - 200, window.w, "center")

	for _, button in pairs(self.buttons) do
		button:draw()
	end
	--[[

	love.graphics.setFont(font["Munro10"])
	love.graphics.print("Hello World", 100, 100)

	local scale = 0.64
	love.graphics.scale(1/0.64) --0.32 : 0.5, 0.64 : 1, 
	love.graphics.setFont(font["Munro10"])
	love.graphics.print("Hello World", 100 * scale, 150 * scale)
	love.graphics.scale(0.64)
	]]
end