OptionState = class("OptionState")

function OptionState:initialize()
	self.backbutton = Button:new(window.w - 110, window.h - 50, 100, 40, {text = "Back", font = font["Arcade30"]})
	self.opensave = Button:new(50, 150, 150, 50, {text = "Open Save Folder", font = font["Arcade20"], wrap = 2})
	self.check1 = CheckBox:new(window.w/2 - 150, 100, 2, true, {255, 255, 255, 255}, true)
	self.check2 = CheckBox:new(window.w/2 +  50, 100, 2, true, {255, 255, 255, 255}, true)
	self.check3 = CheckBox:new(window.w/2 + 250, 100, 2, true, {255, 255, 255, 255}, true)
	self.check1.state = control_mode == "mouse"
	self.check2.state = control_mode == "keyboard"
	self.check3.state = control_mode == "smart_keyboard"
	self.slider = Slider:new(50, 250, 400, 25, 0, 100, math.floor(love.audio.getVolume() * 100 + 0.5), 10)
end

function OptionState:update(dt)
	if keys.escape then
		game:pop()
	end
	if self.backbutton:update(dt) then
		game:pop()
	end
	if self.opensave:update(dt) then
		love.system.openURL("file://"..love.filesystem.getSaveDirectory())
	end
	if self.check1:update(dt) then
		control_mode = "mouse"
		self.check1.state = true
		self.check2.state = false
		self.check3.state = false
	end
	if self.check2:update(dt) then
		control_mode = "keyboard"
		self.check1.state = false
		self.check2.state = true
		self.check3.state = false
	end
	if self.check3:update(dt) then
		control_mode = "smart_keyboard"
		self.check1.state = false
		self.check2.state = false
		self.check3.state = true
	end
	if self.slider:update(dt) then
		love.audio.setVolume(self.slider.value / 100)
		prefs.volume = self.slider.value
	end
end

function OptionState:draw()
	love.graphics.setColor(100, 100, 100, 255)
	love.graphics.rectangle("fill", 0, 0, window.w, window.h)

	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.setFont(font["Arcade50"])
	love.graphics.printf("Options", 0, 0, window.w, "center")

	love.graphics.setFont(font["Arcade30"])
	love.graphics.print("Control Mode:", 50, 70)

	love.graphics.setColor(255, 255, 255)
	love.graphics.setFont(font["Munro30"])
	love.graphics.printf("Mouse:", window.w/2 - 300, 100, 150, "right")
	love.graphics.printf("Keyboard:", window.w/2 - 100, 100, 150, "right")
	love.graphics.printf("Smart Keyboard:", window.w/2 + 100, 68, 150, "right")

	self.backbutton:draw()
	self.opensave:draw()
	self.check1:draw()
	self.check2:draw()
	self.check3:draw()
	self.slider:draw()

	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.setFont(font["Arcade30"])
	love.graphics.print("Volume:", 50, 220)
	love.graphics.setColor(0, 0, 0, 255)
	love.graphics.setFont(font["Arcade20"])
	local value = self.slider.value
	love.graphics.print(value, self.slider.x + self.slider.w + 10, self.slider.y)

end